import es
import popuplib
import keymenulib
import playerlib
import keyvalues
import gamethread

timeout = 30

votes = 0
totalvotes = 0
totalpossible = 0
totalabstain = 0
donesomething = 0
voteopen = 0

keygroupname = ""
keyname = ""
selection = ""
selection_val = ""

menu_locked = 0

vote_menu = None
p_main_menu = None

voteMembersDict = None
manageDict = {}

#Load block
def load():
    global vote_menu
    global p_main_menu
    global voteMembersDict
    global manageDict
    
    #Load keygroups
    es.keygroupload('votemembers', '|clansuite_cv')
    es.keygroupload('general_management', '|clansuite_cv')
    es.keygroupload('user_management', '|clansuite_cv')
    
    voteMembersDict = keyvalues.getKeyGroup("votemembers")
    
    manageDict["general_management"] = keyvalues.getKeyGroup("general_management")
    manageDict["user_management"] = keyvalues.getKeyGroup("user_management")
    
    #Creates Vote Menu
    vote_menu = popuplib.easymenu('vote_menu', None, final_vote)
    vote_menu.settitle('Choose your vote:')
    vote_menu.addoption('1', 'Yes')
    vote_menu.addoption('0', 'No')
    vote_menu.addoption('-1', 'Abstain')

    p_main_menu = popuplib.easymenu('ClanSuite: ClanVote Menu', None, menu_choice)
    p_main_menu.addoption('general_management', 'General Options')
    p_main_menu.addoption('user_management', 'User Options')
    p_main_menu.menuselect = "clansuite_cv/is_unlocking"
    
    es.regsaycmd('!clanvote', 'clansuite_cv/main_menu', 'Clan Suite Menu')

def unload():
    es.keygroupdelete('votemembers')
    es.keygroupdelete('general_management')
    es.keygroupdelete('user_management')
    es.unregsaycmd('!clanvote')
    vote_menu.delete()
    
def main_menu():
    global menu_locked
    user = es.getcmduserid()
    user_steam = es.getplayersteamid(user)
    ok = 0
    for i in voteMembersDict:
        if i.getName() == user_steam:
            ok = 1 
    if ok == 1:
        if menu_locked == 0:
            menu_locked = 1
            p_main_menu.send(user)
        else:
            es.tell(user, "#multi", "#green[CS]#default This menu is currently locked.")
    else:
        es.tell(user, "#multi", "#green[CS]#default You are not allowed to access this.")   

def is_unlocking():
    global menu_locked
    if es.server_var['_popup_choice'] == '10':
        menu_locked = 0

def check_selection():
    global menu_locked
    if es.server_var['_popup_choice'] == '10':
        if es.server_var['_popup_name'] == 'commandlist':
            menu_locked = 0
            main_menu()
        if es.server_var['_popup_name'] == 'optionlist' or es.server_var['_popup_name'] == 'playerlist':
            menu_choice(es.server_var['_popup_userid'], keygroupname, 'p_main_menu')
    
def menu_choice(userid, choice, popupname):
    global keygroupname
    keygroupname = choice
    c_list = popuplib.easymenu('commandlist', None, command_choice)
    c_list.settitle('Commands available')
    for i in manageDict[keygroupname]:
        c_list.addoption(i.getName(), i["name"])
    c_list.menuselect = "clansuite_cv/check_selection"
    c_list.send(userid)
    c_list.delete
    
def command_choice(userid, choice, popupname):
    global keyname
    keyname = choice
    if keygroupname == 'general_management':
        option_list_popup()
    elif keygroupname == 'user_management':
        player_list_popup()
    else:
        es.tell(userid, '#multi', '#green[CS]#default Problem choosing command.')
    
def option_list_popup():
    o_list = popuplib.easymenu('optionlist', None, option_choice)
    o_list.settitle(manageDict[keygroupname][keyname]["name"] + ' options\nChoose the option to vote for:')
    for i in manageDict[keygroupname][keyname]:
        if i.getName() != "rcon" and i.getName() != "name":
            o_list.addoption(i.getName(), manageDict[keygroupname][keyname][i.getName()])
    o_list.menuselect = "clansuite_cv/check_selection"            
    o_list.send(es.getcmduserid())
    o_list.delete
    
def player_list_popup():
    p_list = popuplib.easymenu('playerlist', None, player_choice)
    p_list.settitle(manageDict[keygroupname][keyname]["name"] + ' options\nChoose the option to vote for:')
    myPlayerList = playerlib.getPlayerList()
    for ply in myPlayerList:
        p_list.addoption(es.getuserid(ply.attributes["name"]), ply.attributes["name"])   
    p_list.menuselect = "clansuite_cv/check_selection"
    p_list.send(es.getcmduserid())
    p_list.delete
    
def option_choice(userid, choice, popupname):
    global selection
    global selection_val
    global votes
    global totalvotes
    global totalpossible
    global totalabstain
    global vote_menu
    
    selection = choice
    selection_val = manageDict[keygroupname][keyname][selection]
    votes = 0
    totalvotes = 0
    totalpossible = 0
    totalabstain = 0
    
    vote_menu.delete
    vote_menu = popuplib.easymenu('vote_menu', None, final_vote)
    vote_menu.settitle('Vote to execute ' + manageDict[keygroupname][keyname]["name"] + ": " + selection_val)
    vote_menu.addoption('1', 'Yes')
    vote_menu.addoption('0', 'No')
    vote_menu.addoption('-1', 'Abstain')
    gamethread.delayedname(timeout, 'cb_vote_timeout', final_vote, (userid, '-2', 'vote_menu'))
    voteopen = 1
    myPlayerList = playerlib.getPlayerList()
    for ply in myPlayerList:
        voteask(es.getuserid(ply.attributes["name"]))

def player_choice(userid, choice, popupname):
    global selection
    global selection_val
    global votes
    global totalvotes
    global totalpossible
    global totalabstain
    global vote_menu
    global menu_locked

    selection = choice
    selection_val = es.getplayername(selection)
    user = choice
    user_steam = es.getplayersteamid(user)
    ok = 0
    for i in voteMembersDict:
        if i.getName() == user_steam:
            ok = 1

    if ok == 0:
        votes = 0
        totalvotes = 0
        totalpossible = 0
        totalabstain = 0
        vote_menu.delete
        vote_menu = popuplib.easymenu('vote_menu', None, final_vote)
        vote_menu.settitle('Vote to ' + manageDict[keygroupname][keyname]["name"] + ' ' + selection_val)
        vote_menu.addoption('1', 'Yes')
        vote_menu.addoption('0', 'No')
        vote_menu.addoption('-1', 'Abstain')
        gamethread.delayedname(timeout, 'cb_vote_timeout', final_vote, (userid, '-2', 'vote_menu'))
        voteopen = 1
        myPlayerList = playerlib.getPlayerList()
        for ply in myPlayerList:
            voteask(es.getuserid(ply.attributes["name"]))
    else:
        menu_locked = 0
        es.tell(userid, '#multi', '#green[CS]#default ClanVote cancelled.')
        es.tell(userid, '#multi', '#green[CS]#default You cannot start a ClanVote on a clan member.')

def voteask(userid):
    global totalpossible
    global vote_menu
    user_steam = es.getplayersteamid(userid)
    ok = 0
    for i in voteMembersDict:
        if i.getName() == user_steam:
            ok = 1
    if ok == 1:
        totalpossible += 1
        es.tell(userid, '#multi', '#green[CS]#default A ClanVote has been requested for #green' + manageDict[keygroupname][keyname]["name"] + ': ' + selection_val + '#default.')
        es.tell(userid, '#multi', '#green[CS]#default Please vote using the popup window shown.')
        vote_menu.send(userid)

def final_vote(userid, choice, popupname):
    if voteopen == 1:
        global votes
        global totalvotes
        global totalpossible
        global totalabstain
        global menu_locked
    
        if choice == '1':
            es.tell(userid, '#multi', '#green[CS]#default You voted#lightgreen Yes.')
        elif choice == '0':
            es.tell(userid, '#multi', '#green[CS]#default You voted#lightgreen No.')
        elif choice == '-1':
            es.tell(userid, '#multi', '#green[CS]#default You voted#lightgreen Abstain.')
            
        if votes < (totalpossible / 2) + 1 and totalabstain < (totalpossible / 2) + 1 and (totalvotes - votes) <= totalpossible - ((totalpossible / 2) + 1) and totalvotes < totalpossible:
            if choice != '-2':
                totalvotes += 1
                if choice == '1':
                    votes += 1
                elif choice == '-1':
                    totalabstain += 1
            
                if votes >= (totalpossible / 2) + 1 or (((totalvotes - votes) > totalpossible - ((totalpossible / 2) + 1) or totalvotes >= totalpossible) and totalabstain < (totalpossible / 2) + 1):
                    gamethread.cancelDelayed('cb_vote_timeout')
                    menu_locked = 0
                    voteopen = 0
                    es.msg('#multi', '#green[CS]#default A clan vote has been voted for.')
                    es.msg('#multi', '#green[CS]#lightgreen ' + str((totalpossible / 2) + 1) + ' vote(s)#default required from#lightgreen ' + str(totalpossible) + ' able voter(s)#default.')
                    es.msg('#multi', '#green[CS]#default Vote results: Yes(#lightgreen' + str(votes) + '#default), No(#lightgreen' + str(totalvotes - votes - totalabstain) + '#default), Abstain(#lightgreen' + str(totalabstain) + '#default)')
                    if votes >= (totalpossible / 2) + 1:
                        es.msg('#multi', '#green[CS]#lightgreen Vote passed. Will execute #green' + manageDict[keygroupname][keyname]["name"] + ': ' + selection_val + '#lightgreen.')
                        rcon_cmd = manageDict[keygroupname][keyname]["rcon"]
                        rcon_cmd = rcon_cmd.replace("<var>", str(selection))
                        gamethread.delayed(3, es.server.cmd, (rcon_cmd))
                    else:
                        es.msg('#multi', '#green[CS]#lightgreen Vote failed. Will not execute #green' + manageDict[keygroupname][keyname]["name"] + ': ' + selection_val + '#lightgreen.')
                elif totalabstain >= (totalpossible / 2) + 1:
                    gamethread.cancelDelayed('cb_vote_timeout')
                    menu_locked = 0
                    voteopen = 0
            else:
                menu_locked = 0
                voteopen = 0
                myPlayerList = playerlib.getPlayerList()
                for ply in myPlayerList:
                    inform_timeout(es.getuserid(ply.attributes["name"]))
    else:
        es.msg('#multi', '#green[CS]#default Voting has already been closed.')

def inform_abstain(user):
    user_steam = es.getplayersteamid(user)
    ok = 0
    for i in voteMembersDict:
        if i.getName() == user_steam:
            ok = 1
    if ok == 1:
        es.tell(user, '#multi', '#green[CS]#default No global message will be sent, due to too many abstentions.')

def inform_timeout(user):
    user_steam = es.getplayersteamid(user)
    ok = 0
    for i in voteMembersDict:
        if i.getName() == user_steam:
            ok = 1
    if ok == 1:
        es.tell(user, '#multi', '#green[CS]#default The ClanVote timed out.')
        es.tell(user, '#multi', '#green[CS]#default No global message will be sent, due to a timeout.')
